# -*- coding: cp1252 -*-
import es, playerlib, random, weaponlib
#config
water_effect = 1 # 1 = on; 2 = off
#

# Information du script.
info = es.AddonInfo()
info.name = "FreeZe"
info.version = "1.0"
info.author = "Sulff"
info.basename = "Freezemod"
es.ServerVar('FreeZe', info.version, 'Sulff').makepublic()
#

cut_count = {}
cuts_to_unfreeze = 15 # nombre de coups de cut necessaire pour defreeze le joueur
gunlist = ('weapon_glock', 'weapon_usp', 'weapon_p228', 'weapon_deagle', 'weapon_fiveseven', 'weapon_elite')


def es_map_start(ev):
    es.stringtable('downloadables', 'sound/freezemod/sound_glass_1.mp3')
    es.server.queuecmd("mp_friendlyfire 1") # FF on requis pour permettre le defreeze (detection des coups de cut par player_hurt())
              
def player_activate(ev):
    userid = ev['userid']
    cut_count[userid] = 0

def player_death(ev):
    check_team()

def player_disconnect(ev):
    check_team()
    
def player_spawn(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    myPlayer.set('health', 612)
    # on met la sante a 612 pour que a affiche 100 et que le joueur ne meure pas arrive a 0

    for player in playerlib.getPlayerList('#all'):
        current_player = playerlib.getPlayer(player)
        current_player.freeze = 0
        es.server.queuecmd("es_fire %s !self color \"255 255 255\""%player)
        es.server.queuecmd("es_fire %s !self addoutput \"rendermode 1\""%player)
        es.server.queuecmd("es_fire %s !self alpha 255"%userid)
        
def player_hurt(ev):
    userid = ev['userid']
    attacker = ev['attacker']
    userid_team = ev['es_userteam']
    attacker_team = ev['es_attackerteam']
    myPlayer = playerlib.getPlayer(userid)
    



    # event freeze
    if myPlayer.health <= 512:
        myPlayer.health = 512
        # on met a 512 pour que la sante ne s'affiche pas
        myPlayer.freeze = 1
        es.server.queuecmd("es_fire %s player_weaponstrip strip"%(userid))
        
        handle = es.getplayerhandle(userid) # on prend l'index du joueur a comparer 
        for index in weaponlib.getIndexList('#all'): # boucle sur tout les index a comparer
            if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle: # on compare l'index du propritaire de l'arme  l'index du joueur touch
                es.server.queuecmd('es_xremove %s'%index) # si ce sont les mme, on fait disparaitre l'arme
                
        es.server.queuecmd("es_fire %s !self color \"0 255 255\""%userid)
        es.server.queuecmd("es_fire %s !self addoutput \"rendermode 1\""%userid)
        es.server.queuecmd("es_fire %s !self alpha 225"%userid)

        check_team()
        
    elif water_effect:
        es.fire("%s !self DispatchEffect WaterSurfaceExplosion"%userid)

    # on bloque les hp une fois freez
    if myPlayer.freeze == 1:
        myPlayer.health = 512

    # event defreeze
    if (userid_team == attacker_team) and (myPlayer.freeze == 1):
        if ev['weapon'] == 'knife':
            cut_count[userid] += 1
            es.emitsound('player', attacker, "freezemod/sound_glass_1.mp3", 0.4, 0.3)
            if cut_count[userid] >= cuts_to_unfreeze:
                cut_count[userid] = 0
                
                myPlayer.health = 612

                es.server.queuecmd("es_fire %s !self color \"255 255 255\""%userid)
                es.server.queuecmd("es_fire %s !self alpha 255"%userid)
                rand = random.randint(0,5)
                es.server.queuecmd("es_give %s %s"%(userid, gunlist[rand])) # on donne une arme de poing au hasard lors du defreez
                


                myPlayer.freeze = 0

def check_team():
    TerroList = playerlib.getPlayerList('#t, #alive')
    CtList = playerlib.getPlayerList('#ct, #alive')

    slay_team(TerroList)
    slay_team(CtList)
    
def slay_team(playerlist):
    found_unfreeze = True
    for player in playerlist:
        loop_player = playerlib.getPlayer(player)
        if loop_player.freeze == 0:
            found_unfreeze = False
            break

    if found_unfreeze:
        for player in playerlist:
            es.sexec(player, 'kill')
